/**
 * Copyright (c) 2019 Inomera Research.
 * @author Burak Soykal
 */

#import "FNMInboxStatusCount.h"

@implementation FNMInboxStatusCount

+(NetmeraInboxStatus) getInboxStatus:(NSUInteger) code {
    switch (code) {
        case NetmeraInboxStatusDeleted:
            return NetmeraInboxStatusDeleted;
            break;
        case NetmeraInboxStatusRead:
            return NetmeraInboxStatusRead;
            break;
        case NetmeraInboxStatusUnread:
            return NetmeraInboxStatusUnread;
            break;
        case NetmeraInboxStatusAll:
        default:
            return NetmeraInboxStatusAll;
    }
}

+(NSDictionary *) parseInboxCountForStatusToMap:(NetmeraInboxCountResponse*) response {
    NSMutableDictionary *data = [NSMutableDictionary dictionary];
    data[@"7"] = [NSNumber numberWithInteger:[response countForStatus: NetmeraInboxStatusAll]];
    data[@"1"] = [NSNumber numberWithInteger:[response countForStatus: NetmeraInboxStatusRead]];
    data[@"2"] = [NSNumber numberWithInteger:[response countForStatus: NetmeraInboxStatusUnread]];
    data[@"4"] = [NSNumber numberWithInteger:[response countForStatus: NetmeraInboxStatusDeleted]];
    return data;
}

@end
